﻿# -*- coding: utf-8 -*-
$LOAD_PATH.push(Dir.pwd)
require "gphys_const"
require "gphys_methods"
require "gphys_time"
require "numru/ggraph"
include NumRu

dir  = ARGV[0]
vname = ARGV[1]
iyrs = ARGV[2].to_i
iyre = ARGV[3].to_i
solswitch = ARGV[4].dup
colorswitch = ARGV[5].dup
logswitch = ARGV[6].dup
rmissflag = false

if solswitch == "true" then
  solswitch = true
else 
  solswitch = false
end
if colorswitch == "true" then
  colorswitch = true
else 
  colorswitch = false
end
if logswitch == "true" then
  logswitch = true
else 
  logswitch = false
end
#title = MonNames[imon-1]

gphys = GPhys::NetCDF_IO.open(dir+'/'+vname+".nc", vname)

if vname == 'KMHF_d'
  DCL.sgscmn(34) #Basic-Windspeed
elsif vname == 'NewmanF_d'
  DCL.sgscmn(34) #Basic-Windspeed
elsif vname == 'SurfMajCompIce'
  DCL.sgscmn(27) #Basic->Blues
elsif vname == 'V_tang'
  for i in 0..gphys.att_names.size - 1
    if gphys.att_names[i] == 'missing_value' then
      rmiss = gphys.get_att('missing_value')[0]
      rmissflag = true
    end
  end
end 

#< DCLのオープンと設定 >
DCL.gropn(2)
#DCL.sldiv('y',2,2)           # 2x2に画面分割, 'y'=yoko: 左上→右上→左下...
DCL.sgpset('lcntl', false)   # 制御文字を解釈しない
DCL.sgpset('lfull',true)     # 全画面表示
DCL.uzfact(0.75)             # 座標軸の文字列サイズを 0.75 倍
DCL.sgpset('lfprop',true)    # プロポーショナルフォントを使う
if vname =='V_tang'
  if rmissflag then
    DCL.glpset('lmiss',true)
    DCL.glpset('rmiss',rmiss)
  end
end
#< GGraph による 描画 >
#GGraph.set_fig( 'viewport'=>[0.1,0.6,0.15,0.85], 'window'=>[0,360,nil,nil])
GGraph.set_fig('viewport'=>[0.25,0.7,0.15,0.6])
#GGraph.set_fig 'itr'=>10, 'viewport'=>[0.15,0.85,0.1,0.6], 'window'=>[0,360,-90,90]
#GGraph.set_fig 'viewport'=>[0.15,0.85,0.1,0.6], 'window'=>[0,360,-90,90]
#GGraph.set_map 'coast_world'=>true, 'grid'=>false
GGraph.set_axes('yside'=>'lr','xside'=>'tb')
#GGraph.set_axes('xlabelint'=>100)
#GGraph.set_axes('ylabelint'=>15)
#GGraph.set_axes('xlabelint'=>90)
#GGraph.set_axes('ylabelint'=>30)


gphysout = maketime( dir, iyrs, iyre, gphys )

if vname == 'KMHF_d' && solswitch then
  gphysout = calc_sol(gphysout)
  p "kotti"
end

# レベル＆パターンを陽に指定
# パタンの方が1つ多→±∞ まで

#if vname == 'SurfTemp'
#  levels = [140, 145, 150, 155, 160, 165, 170, 175, 180, 185, 190, 195, 200, 205, 210, 215, 220, 225, 230, 235, 240, 245, 250, 255, 260]
#  patterns = [20999, 23999, 26999, 29999, 32999, 35999, 38999, 41999, 44999, 47999, 50999, 53999, 56999, 59999, 62999, 65999, 68999, 71999, 74999, 77999, 80999, 83999, 86999, 89999, 92999]
#elsif vname == 'KMHF_d'
##  GGraph.fig(gphysout.coord("Ls"),gphysout.data,"window"=>[0,360,0,2.0e-5])
#  if colorswitch && solswitch then
#   # デフォルト
#    if logswitch then
#      levels = [0, 1.0e-9, 1.0e-8, 1.0e-7, 1.0e-6, 1.0e-5, 1.0e-4, 1.0e-3, 1.0e-2, 1.0e-1, 1.0]
#      patterns = [0, 14999, 24999, 34999, 44999, 54999, 64999, 74999, 84999, 94999 ]
#    else
#      levels = [0.0e0, 1.0e-8, 8.88e-6, 1.78e-5, 2.66e-5, 3.55e-5, 4.44e-5, 5.32e-5, 6.21e-5, 7.10e-5, 7.99e-5, 8.88e-5, 9.77e-5, 1.07e-4, 1.15e-4, 1.24e-4, 1.33e-4, 1.42e-4, 1.51e-4, 1.60e-4, 1.69e-4, 1.78e-4, 1.86e-4, 1.95e-4, 2.04e-4, 2.13e-4, 2.22e-4, 2.30e-4, 2.40e-4,2.49e-4]
#      patterns = [0, 10999, 13999, 16999, 19999, 22999, 25999, 28999, 31999, 34999, 37999, 40999, 43999, 46999, 49999, 52999, 55999, 58999, 61999, 64999, 67999, 70999, 73999, 76999, 79999, 82999, 85999, 88999, 91999, 94999 ]
#    end
#  elsif colorswitch && !solswitch then
#    # デフォルト
#    levels = [0.0e0, 1.0e-12, 1.0e-10, 2.0e-10, 3.0e-10, 4.0e-10, 5.0e-10, 6.0e-10, 7.0e-10, 8.0e-10, 9.0e-10, 1.0e-9, 1.1e-9, 1.2e-9, 1.3e-9, 1.4e-9, 1.5e-9, 1.6e-9, 1.7e-9, 1.8e-9, 1.9e-9, 2.0e-9, 2.1e-9, 2.2e-9, 2.3e-9, 2.4e-9, 2.5e-9, 2.6e-9, 2.7e-9, 2.8e-9 ]
#    # さらに小さい
#    #levels = [0.0e0, 1.0e-12, 1.0e-11, 2.0e-11, 3.0e-11, 4.0e-11, 5.0e-11, 6.0e-11, 7.0e-11, 8.0e-11, 9.0e-11, 1.0e-10, 1.1e-10, 1.2e-10, 1.3e-10, 1.4e-10, 1.5e-10, 1.6e-10, 1.7e-10, 1.8e-10, 1.9e-10, 2.0e-10, 2.1e-10, 2.2e-10, 2.3e-10, 2.4e-10, 2.5e-10, 2.6e-10, 2.7e-10, 2.8e-10 ]
#    #levels = [0.0e0, 1.0e-12, 1.0e-11, 2.0e-11, 3.0e-11, 4.0e-11, 5.0e-11, 6.0e-11, 7.0e-11, 8.0e-11, 1.0e-10, 2.0e-10, 3.0e-10, 4.0e-10, 5.0e-10, 6.0e-10, 7.0e-10, 8.0e-10, 9.0e-10, 1.0e-9, 1.1e-9, 1.2e-9, 1.3e-9, 1.4e-9, 1.5e-9, 1.6e-9, 1.7e-9, 1.8e-9, 1.9e-9,2.0e-9 ]
#    patterns = [0, 10999, 13999, 16999, 19999, 22999, 25999, 28999, 31999, 34999, 37999, 40999, 43999, 46999, 49999, 52999, 55999, 58999, 61999, 64999, 67999, 70999, 73999, 76999, 79999, 82999, 85999, 88999, 91999, 94999 ]
#
#  elsif solswitch && !colorswitch then
#    levels = [0.0e0, 1.0e-8, 7.14e-4, 1.42e-3, 2.13e-3, 2.84e-3, 3.55e-3, 4.26e-3, 4.97e-3, 5.68e-3, 6.39e-3, 7.10e-3, 7.81e-3, 8.52e-3, 9.24e-3, 9.94e-3, 1.07e-2, 1.14e-2, 1.21e-2, 1.28e-2, 1.35e-2, 1.42e-2, 1.49e-2, 1.56e-2, 1.63e-2, 1.70e-2, 1.78e-2, 1.85e-2, 1.92e-2, 1.99e-2, 2.06e-2]
#    patterns = [0, 10999, 13999, 16999, 19999, 22999, 25999, 28999, 31999, 34999, 37999, 40999, 43999, 46999, 49999, 52999, 55999, 58999, 61999, 64999, 67999, 70999, 73999, 76999, 79999, 82999, 85999, 88999, 91999, 94999 ]
#  else
#    levels = [0.0e0, 1.0e-10, 0.80e-8, 1.60e-8, 2.40e-8, 3.20e-8, 4.00e-8, 4.80e-8, 5.60e-8, 6.40e-8, 7.20e-8, 8.00e-8, 8.80e-8, 9.60e-8, 1.04e-7, 1.12e-7, 1.20e-7, 1.28e-7, 1.36e-7, 1.44e-7, 1.52e-7, 1.60e-7, 1.68e-7, 1.76e-7, 1.84e-7, 1.92e-7, 2.00e-7, 2.08e-7, 2.16e-7, 2.24e-7, 2.32e-7]
#    patterns = [0, 10999, 13999, 16999, 19999, 22999, 25999, 28999, 31999, 34999, 37999, 40999, 43999, 46999, 49999, 52999, 55999, 58999, 61999, 64999, 67999, 70999, 73999, 76999, 79999, 82999, 85999, 88999, 91999, 94999 ]
#  end
#elsif vname =='NewmanF_d'
##  GGraph.fig(gphysout.coord("Ls"),gphysout.data,"window"=>[0,360,0,2.0e-6])
#  levels = [0.0e0, 1.0e-10, 1.40e-8, 2.80e-8, 4.20e-8, 5.60e-8, 6.00e-8, 7.40e-8, 9.80e-8, 1.12e-7, 1.26e-7, 1.40e-7, 1.54e-7, 1.68e-7, 1.82e-7, 1.96e-7, 2.10e-7, 2.24e-7, 2.38e-7, 2.52e-7, 2.66e-7, 2.80e-7, 2.94e-7, 3.08e-7, 3.22e-7, 3.36e-7, 3.50e-7, 3.64e-7, 3.78e-7, 3.82e-7, 3.96e-7, 4.10e-7]
#  patterns = [0, 10999, 13999, 16999, 19999, 22999, 25999, 28999, 31999, 34999, 37999, 40999, 43999, 46999, 49999, 52999, 55999, 58999, 61999, 64999, 67999, 70999, 73999, 76999, 79999, 82999, 85999, 88999, 91999, 94999, 98999]
#elsif vname == 'TauXB'
#elsif vname == 'TauYB'
#elsif vname == 'Tau'
##  GGraph.fig(gphysout.coord("Ls"),gphysout.data,"window"=>[0,360,0,0.01])
#  levels = [0.0e0, 1.0e-10, 0.001, 0.002, 0.003, 0.004, 0.005, 0.006, 0.007, 0.008, 0.009, 0.010, 0.011, 0.012, 0.013, 0.014, 0.015, 0.016, 0.017, 0.018, 0.019, 0.020, 0.021, 0.022, 0.023, 0.024, 0.025, 0.026, 0.027, 0.028, 0.029, 0.030]
#  patterns = [0, 10999, 13999, 16999, 19999, 22999, 25999, 28999, 31999, 34999, 37999, 40999, 43999, 46999, 49999, 52999, 55999, 58999, 61999, 64999, 67999, 70999, 73999, 76999, 79999, 82999, 85999, 88999, 91999, 94999,98999]
#elsif vname == 'SurfMajCompIce'
#  levels = [0,1, 20, 40, 60, 80, 100, 120, 140, 160, 180, 200, 220, 240, 260, 280, 300, 320, 340, 360, 380, 400, 420, 440, 460, 480, 500, 520, 540, 560, 580, 600, 620, 640, 680, 700, 720, 740, 760, 780, 800, 820, 840, 860, 880, 900, 920, 940]
#  patterns = [0, 16999, 18999, 20999, 22999, 24999, 26999, 28999, 30999, 32999, 34999, 36999, 38999, 40999, 42999, 44999, 46999, 48999, 50999, 52999, 54999, 56999, 58999, 60999, 62999, 64999, 66999, 68999, 70999, 72999, 74999, 75999, 76999, 77999, 78999, 79999, 80999, 81999, 82999, 83999, 84999, 85999, 86999, 87999, 88999, 89999, 90999]
#elsif vname == 'Ps'
#  levels = [100, 125, 150, 175, 200, 225, 250, 275, 300, 325, 350, 375, 400, 425, 450, 475, 500, 525, 550, 575, 600, 625, 650, 675, 700, 725, 750, 775, 800, 825, 850, 875, 900, 925, 950, 975, 1000, 1025, 1050, 1075, 1100, 1125, 1150, 1175, 1200, 1225, 1250, 1275, 1300, 1325, 1350, 1375, 1400, 1425, 1450, 1475, 1500]
#  patterns = [0, 20999, 21999, 22999, 23999, 24999, 25999, 26999, 27999, 28999, 29999, 30999, 31999, 32999, 33999, 34999, 35999, 36999, 37999, 38999, 39999, 40999, 42999, 44999, 46999, 48999, 50999, 52999, 54999, 56999, 58999, 60999, 62999, 64999, 66999, 68999, 70999, 71999, 72999, 73999, 74999, 75999, 76999, 77999, 78999, 79999, 80999, 81999, 82999, 83999, 84999, 85999, 86999, 87999, 88999, 89999, 90999]
#elsif vname == 'DDAF_d'
##  GGraph.fig(gphysout.coord("Ls"),gphysout.data,'window'=>[0,360,0,1.0e-10])
#elsif vname == 'DTHF_d'
##  GGraph.fig(gphysout.coord("Ls"),gphysout.data,'window'=>[0,360,0,5.0e-9])
#end

p gphysout.shape

GGraph.line(gphysout[0,0,false],true,'annot'=>false)
#GGraph.tone( gphysout, true, 'lev'=>levels, 'pat'=>patterns, 'map_axes'=>true, 'annotate'=>false ,'exchange'=>true)
#if logswitch then
#  GGraph.color_bar('constwidth'=>true, 'labelintv'=>1)
#else
#  GGraph.color_bar
#end
##if vname == 'KMHF_d' or vname == 'NewmanF_d' or vname == 'Ps' or vname == 'Tau',
#  ice = GPhys::NetCDF_IO.open(dir+'/SurfMajCompIce.nc', 'SurfMajCompIce')
#  iceout = maketime( dir, iyrs, iyre, ice)
##  iceout = iceout * (-1)
##  DCL.uepset('LTONE',false)
##  tlev1 = 10.0
##  tlev2 = DCL.glpget('RMISS')
#
#  #levels = [0,1.0e-1, 1, 100,200, 300,400,500,600,700, 800, 900, 940]
#  levels = [1]
##p tlev2
##  DCL::uestlv(tlev1,tlev2,301)
##GGraph.contour(iceout,false,'levels'=>levels,'line_type'=>2,'label'=>false,'exchange'=>true)
#GGraph.contour(iceout,false,'levels'=>levels,'index'=>9,'label'=>false,'exchange'=>true)
##  DCL::uetone(iceout.val)
##  DCL::udcntr(iceout.val) 
#
##GGraph.tone(iceout,false,'ltone'=>false)
#  DCL::ueitlv
#end

#DCL::uxmttl('T', ' ', 1.0)
#DCL::uxmttl('T', title, -1.0)


DCL.grcls
#if File.exists?('./sagyou.nc') then
#  File.delete('./sagyou.nc')
#end

