﻿# -*- coding: utf-8 -*-
$LOAD_PATH.push(Dir.pwd)
require "gphys_const"
require "gphys_methods"
require "gphys_time"
require "gphys_tmp_calc"
require "numru/ggraph"
include NumRu

dir  = ARGV[0].dup.to_s
vname = ARGV[1]
iyrs = ARGV[2].to_i
iyre = ARGV[3].to_i
lon = ARGV[4].to_i
ls = ARGV[5].to_i
days = ARGV[6].to_i
local_time = ARGV[7].to_i
unit = ARGV[8].to_s
ls_dir = ARGV[9].dup.to_s
overwrite_topog_switch = ARGV[10].dup.to_s
ogihara_script_switch = ARGV[11].dup.to_s

if overwrite_topog_switch == 'true'
  overwrite_topog_switch = true
  sp_dir = ARGV[12].dup.to_s
  sp_file = ARGV[13].dup.to_s
  sp_vname = ARGV[14].dup.to_s
#  ext_time(iyrs, iyre, sp_dir, sp_file, sp_vname, dir, vname, vname)
  sp_dir = add_slash(sp_dir)
  sp = GPhys::IO.open(sp_dir + sp_file+ '.nc', sp_vname)
else
  overwrite_topog_switch = false
end

if ogihara_script_switch == 'true'
  ogihara_script_switch = true
else
  ogihara_script_switch = false
end


time_array = ls_to_time(iyrs, iyre, ls_dir, [ls])
lt_array = local_starting_time_and_ending_time(time_array[0],days, lon, ls_dir)
  


#title = MonNames[imon-1]
array = diff(vname)
vname = array[0]
gphys = GPhys::NetCDF_IO.open(dir+'/'+vname+".nc", vname)
if gphys.axnames[-1] == 'PlanetLonFromVE' || gphys.axnames[-1] == 'Ls'
  ls_dir = add_slash(ls_dir)
  ls = GPhys::IO.open(ls_dir+'PlanetLonFromVE.nc','PlanetLonFromVE')
  lt_array[0] = ls.cut("time"=>lt_array[0]).val[0]
  lt_array[1] = ls.cut("time"=>lt_array[1]).val[0]
  gphysmean = gphys.cut(gphys.axnames[-1]=>lt_array[0]..lt_array[1]).mean(-1)
else
  if ogihara_script_switch
    gphys = select_gphys(gphys.cut("time"=>lt_array[0]..lt_array[1]),dir,vname, nil,lt_array[0],lt_array[1],array[1], 'sp_for_Mars_T021_OnlyTop_MGS.nc')
    gphysmean = local_time_mean(lt_array[0], lt_array[1], gphys, local_time, unit, days)
  end
end

#< DCLのオープンと設定 >
DCL.gropn(2)
#DCL.sldiv('y',2,2)           # 2x2に画面分割, 'y'=yoko: 左上→右上→左下...
DCL.sgpset('lcntl', false)   # 制御文字を解釈しない
#DCL.sgpset('lfull',true)     # 全画面表示
DCL.uzfact(0.75)             # 座標軸の文字列サイズを 0.75 倍
DCL.sgpset('lfprop',true)    # プロポーショナルフォントを使う

#< GGraph による 描画 >
#GGraph.set_fig('viewport'=>[0.1,0.9,0.1,0.9])
GGraph.set_fig('window'=>[0,360,-90,90], 'viewport'=>[0.1,0.8,0.1,0.9])
#GGraph.set_fig 'viewport'=>[0.15,0.85,0.1,0.6], 'window'=>[0,360,-90,90]
#GGraph.set_map 'coast_world'=>true, 'grid'=>false
GGraph.set_axes('ytickint'=>5,'ylabelint'=>30,'xtickint'=>5, 'xlabelint'=>30)

levels = nil
if array[1] == 'surfn2'
  levels = [-0.20, -0.18, -0.16, -0.14, -0.12, -0.10, -0.08, -0.06, -0.04,-0.02, 0.0, 0.02, 0.04, 0.06, 0.08]
  patterns = [10999, 16999, 20999, 30999, 35999, 40999, 49999, 55999, 65999, 75999,80999, 85999, 89999, 95999]
end


# 作図

p gphysmean.shape
if levels
GGraph.tone(gphysmean,true,'lev'=>levels, 'pat'=>patterns,'annotate'=>false)
else
GGraph.tone(gphysmean,true,'annotate'=>false)
end
GGraph.color_bar

if overwrite_topog_switch

  # lev = [0,0e0]
  #GGraph.set_contour_levels('levels'=>lev)
  GGraph.contour(sp,false)
end

#DCL::uxmttl('T', ' ', 1.0)
#DCL::uxmttl('T', title, -1.0)


DCL::grcls
if File.exists?('./sagyou.nc') then
  File.delete('./sagyou.nc')
end
