﻿# -*- coding: utf-8 -*-
$LOAD_PATH.push(Dir.pwd)
require "gphys_const"
require "gphys_methods"
require "gphys_time"
require "gphys_tmp_calc"
require "numru/ggraph"
include NumRu


dir  = ARGV[0]
vname = ARGV[1]
hour = ARGV[2].to_i
yearhour = ARGV[3].to_i
#mon = ARGV[4].to_i
overwrite_topog_switch = ARGV[4].dup.to_s
if overwrite_topog_switch == 'true'
  overwrite_topog_switch = true
  sp_dir = ARGV[5].dup.to_s
  sp_file = ARGV[6].dup.to_s
  sp_vname = ARGV[7].dup.to_s
  sp_dir = add_slash(sp_dir)
  sp = GPhys::IO.open(sp_dir + sp_file+ '.nc', sp_vname)
else
  overwrite_topog_switch = false
end

keep_switch = ARGV[8].dup.to_s
if keep_switch == 'true'
  keep_switch = true
else
  keep_switch = false
end

aspect_switch = ARGV[9].dup.to_s
if aspect_switch == 'true'
  aspect_switch = true
else
  aspect_switch = false
end

if ARGV[10] == 'nil'
  ux_unit = nil
else
  ux_unit = ARGV[10].dup.to_f
end
if ARGV[11] == 'nil'
  uy_unit = nil
else
  uy_unit = ARGV[10].dup.to_f
end



localtime = hour - yearhour
ls = GPhys::NetCDF_IO.open(dir+'/PlanetLonFromVE.nc','PlanetLonFromVE')


#title = 'time =' + hour.to_s + 'hours'  #MonNames[imon-1]
lsout = sprintf("%8.5f", ls.cut("time"=>hour).val[0])
title = 'Ls = ' + lsout.to_s + ' degree'

array = diff(vname)
vname = array[0]
vname2 = array[2]

gphysx = GPhys::NetCDF_IO.open(dir+'/'+vname+".nc", vname)
gphysy = GPhys::NetCDF_IO.open(dir+'/'+vname2+".nc", vname2)


#< DCLのオープンと設定 >
DCL.gropn(2)
#DCL.sldiv('y',2,2)           # 2x2に画面分割, 'y'=yoko: 左上→右上→左下...
DCL.sgpset('lcntl', false)   # 制御文字を解釈しない
DCL.sgpset('lfull',true)     # 全画面表示
DCL.uzfact(0.75)             # 座標軸の文字列サイズを 0.75 倍
#DCL.uzfact(0.71)
#DCL.uzfact(0.69)
#DCL.uzfact(0.5)
DCL.sgpset('lfprop',true)    # プロポーショナルフォントを使う

#< GGraph による 描画 >
#GGraph.set_fig 'itr'=>10, 'viewport'=>[0.15,0.85,0.1,0.6], 'window'=>[0,360,-90,90]
#GGraph.set_fig 'viewport'=>[0.15,0.85,0.1,0.6], 'window'=>[0,360,-90,90]
GGraph.set_fig 'viewport'=>[0.1,0.6,0.1,0.6], 'window'=>[0,360,-90,90]
#GGraph.set_map 'coast_world'=>true, 'grid'=>false
GGraph.set_axes('yside'=>'lr','xside'=>'tb')
GGraph.set_axes('xlabelint'=>30, 'xtickint'=>15)
GGraph.set_axes('ylabelint'=>30)


gphysout1 = dcpam_lt( hour, gphysx )
gphysout2 = dcpam_lt( hour, gphysy )

gphysoutx = select_gphys(gphysout1,dir,vname,nil,hour,nil,array[1])
gphysouty = select_gphys(gphysout2,dir,vname2,nil,hour,nil,array[1])

# レベル＆パターンを陽に指定
# パタンの方が1つ多→±∞まで

if overwrite_topog_switch
  levels = [-6000, -5500, -5000, -4500, -4000, -3500, -3000, -2500, -2000, -1500, -1000, -500, 0, 500, 1000, 1500, 2000, 2500, 3000, 3500, 4000, 4500, 5000, 5500, 6000, ]
  patterns = [11999, 14999, 16999, 18999, 20999, 22999, 24999, 26999, 28999, 30999, 34999, 44999, 54999, 55999, 65999, 75999, 79999, 82999, 84999, 85999, 87999, 89999, 91999,93999,95999, 97999]

  topog = GPhys::NetCDF_IO.open('sp_for_Mars_T021_MGS.nc','topog')
  GGraph.tone( topog, true, 'lev'=>levels, 'pat'=>patterns, 'map_axes'=>true, 'annotate'=>false )
  GGraph.color_bar('constwidth'=>true, 'labelintv'=>1, 'vcent'=>0.4, 'voff'=>0.05)
  GGraph.contour(topog, false, 'lev'=>levels, 'index'=>9991, 'line_type'=>1)
else
  topog = GPhys::NetCDF_IO.open('sp_for_Mars_T021_MGS.nc','topog')
  levels = 0*(NArray.float(7).indgen!)
  mn = DCL.udpget('indxmn')
  GGraph.set_contour_levels('levels'=>levels, 'index'=>mn )
  GGraph.contour(topog,false)
end

#### 単位ベクトルの値を指定する(ug_set_params は UGPACK の内部変数を変更するメソッド
#DCLExt.ug_set_params({'LNRMAL'=>false})
# # スケーリングファクターの値を陽に指定できるようにする(true の場合, 内部的に決定)
#DCLExt.ug_set_params({'XFACT1'=>50/gphysoutx.max, 'YFACT1'=>40/gphysouty.max})

if keep_switch
  scale_array = []
  open('./vec_scale.tmp', 'r') {|f| 
    while line = f.gets
      scale_array << line
    end
  }

  if scale_array.length == 2
    @@vxfxratio = scale_array[0].to_f
    @@vyfyratio = scale_array[1].to_f
  elsif aspect_switch
    vxfxratio, xyfyratio, decide_str, vx, vy = vfratio(gphysoutx, gphysouty, 4.0)
    case decide_str
    when 'fx' then
      @@vxfxratio = vxfxratio
      @@vyfyratio = vy / vx * vxfxratio
    when 'fy' then
      @@vyfyratio = vyfyratio
      @@vxfxratio = vx / vy * vyfyratio
    end
  end
  GGraph.vector( gphysoutx, gphysouty, false, 'annotate'=>false, 'factor'=>4.0,'unit_vect'=>true, 'keep'=>true, 'ux_unit'=>ux_unit, 'uy_unit'=>uy_unit)
  scale_array = [@@vxfxratio, "\n", @@vyfyratio]
  open('./vec_scale.tmp', 'w') {|f|
    scale_array.each{|ratio|
      f.write(ratio)
    }
  }
  p scale_array
elsif aspect_switch
  vxfxratio, xyfyratio, decide_str, vx, vy = vfratio(gphysoutx, gphysouty, 4.0)
  case decide_str
  when 'fx' then
    @@vxfxratio = vxfxratio
    @@vyfyratio = vy / vx * vxfxratio
  when 'fy' then
    @@vyfyratio = vyfyratio
    @@vxfxratio = vx / vy * vyfyratio
  end
  GGraph.vector( gphysoutx, gphysouty, false, 'annotate'=>false, 'unit_vect'=>true, 'ux_unit'=>ux_unit, 'uy_unit'=>uy_unit, 'keep'=>true)
else
  GGraph.vector( gphysoutx, gphysouty, false, 'annotate'=>false, 'factor'=>4.0, 'unit_vect'=>true, 'ux_unit'=>ux_unit, 'uy_unit'=>uy_unit)
end
#if vname == 'KMHF_d' or vname == 'NewmanF_d' or vname == 'Ps' or vname == 'DDAF_d'
#  ice = GPhys::NetCDF_IO.open(dir+'/SurfMajCompIce.nc', 'SurfMajCompIce')
#  iceout = dcpam_lt(hour, ice)
##  iceout = iceout * (-1)
##  DCL.uepset('LTONE',false)
##  tlev1 = 10.0
##  tlev2 = DCL.glpget('RMISS')
#
#  #levels = [1.0e-1]
#  levels = [1.0]
#  #levels = [0,1.0e-1, 1, 100,200, 300,400,500,600,700, 800, 900, 940]
##p tlev2
##  DCL::uestlv(tlev1,tlev2,301)
##GGraph.contour(iceout,false,'levels'=>levels,'line_type'=>2,'label'=>false)
#GGraph.contour(iceout, false, 'levels'=>levels,'index'=>9,'label'=>false)
##  DCL::uetone(iceout.val)
##  DCL::udcntr(iceout.val) 
#
##GGraph.tone(iceout,false,'ltone'=>false)
#  DCL::ueitlv
#end

DCL::uxmttl('T', title, 1.0)
#DCL::uxmttl('T', title, 0.0)



DCL.grcls
