﻿# -*- coding: utf-8 -*-
#
# スナップショット画像 (ベクトル)をアニメ化する
# 2015/12/17 単位ベクトルの縦横比をそろえるを追加
$LOAD_PATH.push(Dir.pwd)
require "gphys_const"
require "gphys_time"
require "my_utils"
require "numru/ggraph"
include NumRu

# 見たいデータファイルの相対パス
dir = '..'

# 重ね書きしたい地形データのある相対パス
#sp_dir = './tmp'
sp_dir = '..'

# 重ね書きしたい地形データ
sp_file = 'sp_for_Mars_T021_MGS'
#sp_file = 'dual_differential_topog'
#sp_file = 'differential_topog'
#sp_file = 'sp_for_Mars_T021_AvarageMGS'

# 重ね書きしたい地形の変数
sp_vname = 'topog'

vnames = ['SurfVel']
figdir = 'figs'
ltfigdir = figdir + '/ltfigs'
#Dir::mkdir( figdir )

##$figfile = Dir[ File.expand_path(ltfigdir)+"/*"] #ディレクトリ内のファイルを絶対パスで受け取る
if File.exists?(ltfigdir) then
   system( 'rm -rf ' + 'ltfigs')
##    figfile.each{ |file|
##      next if /^\.+$/ =~ file
##      File.delete(file)}
##    Dir.rmdir(ltfigdir)
##    Dir::mkdir( ltfigdir )
else
    Dir::mkdir( ltfigdir )
end

iyrs = 11
iyre = 20
#iyrs = 1
iyrs = 5
iyre = 5
#iyrs = 1
#iyre = 1
#lt = [8,9,10]
#lt = [9,10]
#lt = [10]
lt = [270]

# 指定時間を直接指定する(appointed)か, 月ごとにする(month)か
#appointed_switch = 'month'
appointed_switch = 'appointed'
# 地形高度を 0 m 地点のみにするか(false), 等高線でしっかり描くか(true)
overwrite_topog_switch = 'true'
# 時間の単位, 時間単位(hour), 秒単位(sec)
time_unit = 'hour'
#time_unit = 'sec'
#
# フレーム間で単位ベクトルの長さをそろえるか(true)
# true の場合動画全体で単位ベクトルは変わらない. 
# false の場合はフレームごとにかわる.
# vnames の要素毎に配列で指定する
# 例: vnames = ['SurfVel','lev600Vel'] で SurfVel は true, lev600Vel は false の場合
# keep_switch = ['true', 'false'] にする
# そろえる場合 tmp ファイルを作成し, ruby draw_2D_lt_vect.rb が読まれることに vxfactratio を保存する
keep_switch = ['true']
#keep_switch = ['false']
#
# 単位ベクトルの縦横比をそろえるか(true)
# 単位ベクトルの縦横比をそろえる場合(true), 揃えない場合 (false)
# keep_switch と同様にvnames の要素毎に配列で指定する
aspect_switch = ['true']
#aspect_switch = ['false']
#
# 単位ベクトルの値を指定する (fixnum)
# 横方向の単位ベクトルは ux_unit, 縦方向の単位ベクトルは uy_unit に指定. 指定しない場合は 'nil' を入れる.
# nil の場合はおそらく最大値が勝手に入る
# keep_switch と同様にvnames の要素毎に配列で指定する
ux_unit = [30]
uy_unit = [30]
#ux_unit = ['nil']
#uy_unit = ['nil']

# 時間の切だし 
#hours = dcpam_hours(iyrs, iyre, lt, time_unit, appointed_switch)

# lt で指定したLs付近で経度 lon が0時になるように合わせたローカルタイムから days 日後までのアニメーションを作る場合
# 何日分取り出すか
days = 20
#days = 1
# ローカルタイム 0 時をどこにとるか
lon = 0
# ls から時間への変換
time_array = ls_to_time(iyrs,iyre, dir, lt)
# 指定したls(時間)付近でローカルタイムが0 時が lon のところの時間を取り出し
lt_array = local_starting_time_and_ending_time(time_array[0], days, lon, dir)
# 時間の切だし 
hours = dcpam_hours(iyrs, iyre, [lt_array], time_unit, appointed_switch)

if appointed_switch == 'month'
  infix = 'month_'
elsif appointed_switch == 'appointed'
  infix = 'Ls_'
end

if File.exists?('./vec_scale.tmp') then
  system( 'rm ./vec_scale.tmp')
end
imon_order = lt.max.abs.to_i.to_s.length
for ivar in 0..(vnames.length-1)
  if keep_switch[ivar] == 'true'
    system('touch ./vec_scale.tmp')
  end
  for imon in 0..lt.length-1
    hour_order = (hours[1][imon] - hours[0][imon]).abs.to_i.to_s.length
    array = Array.new(hours[1][imon] - hours[0][imon])
    for hour in hours[0][imon].to_i..hours[1][imon].to_i
      p 'vname: ' + vnames[ivar]
      p 'Month: ' + lt[imon].to_s
      p 'hour: ' + hour.to_s

      system('ruby draw_2D_lt_vect.rb ' + dir + ' ' + vnames[ivar] + ' ' + hour.to_s + ' ' + hours[0][imon].to_s + ' ' + overwrite_topog_switch.to_s + ' ' + sp_dir + ' ' + sp_file + ' ' + sp_vname + ' ' + keep_switch[ivar].to_s + ' ' + aspect_switch[ivar].to_s + ' ' + ux_unit[ivar].to_s + ' ' + uy_unit[ivar].to_s)# + ' ' + lt[imon].to_s)
      system("pdf2ps dcl.pdf dcl.ps")
      system("rm dcl.pdf")

      system("pstoimg -type gif -flip r270 dcl.ps")
      system("convert dcl.gif -trim dcl.gif")
      com =  "mv dcl.gif "+ltfigdir+"/dcl_"+vnames[ivar]+"_vec_"+infix+"%0#{imon_order}d"%(lt[imon].to_s)+'_'+"lt%0#{hour_order}d"%(hour - hours[0][imon] + 1) + ".gif" 
      system(com)
      com =  "mv dcl.ps  "+ltfigdir+"/dcl_"+vnames[ivar]+"_vec_"+infix+"%0#{imon_order}d"%(lt[imon].to_s)+'_'+"lt%0#{hour_order}d"%(hour - hours[0][imon] + 1) + ".ps" 
      system(com)

      com = ltfigdir+"/dcl_"+vnames[ivar]+"_vec_"+infix+"%0#{imon_order}d"%(lt[imon].to_s)+'_'+"lt%0#{hour_order}d.gif"%(hour - hours[0][imon] + 1)
      array[hour-hours[0][imon]] = com
    end
    tempname = ltfigdir+"/anim_vec_"+vnames[ivar]+"_"+infix+"%0#{imon_order}d"%(lt[imon].to_s)+".gif"
    make_anime(array, 20, tempname)
  end
  if File.exists?('./vec_scale.tmp') then
    system( 'rm ./vec_scale.tmp')
  end
end

