﻿# -*- coding: utf-8 -*-
$LOAD_PATH.push(Dir.pwd)
require "gphys_const"
require "gphys_methods"
require "gphys_time"
require "numru/ggraph"
include NumRu

dir  = ARGV[0]
vname = ARGV[1]
iyrs = ARGV[2].to_i
iyre = ARGV[3].to_i

#title = MonNames[imon-1]

gphys = GPhys::NetCDF_IO.open(dir+'/'+vname+".nc", vname)

#< DCLのオープンと設定 >
DCL.gropn(2)
#DCL.sldiv('y',2,2)           # 2x2に画面分割, 'y'=yoko: 左上→右上→左下...
DCL.sgpset('lcntl', false)   # 制御文字を解釈しない
#DCL.sgpset('lfull',true)     # 全画面表示
DCL.uzfact(0.75)             # 座標軸の文字列サイズを 0.75 倍
DCL.sgpset('lfprop',true)    # プロポーショナルフォントを使う

#< GGraph による 描画 >
#GGraph.set_fig 'itr'=>10, 'viewport'=>[0.15,0.85,0.1,0.6], 'window'=>[0,360,-90,90]
#GGraph.set_fig 'viewport'=>[0.15,0.85,0.1,0.6], 'window'=>[0,360,-90,90]
#GGraph.set_map 'coast_world'=>true, 'grid'=>false
#GGraph.set_axes('yside'=>'lr','xside'=>'tb')
#GGraph.set_axes('xlabelint'=>100)
#GGraph.set_axes('ylabelint'=>15)
#GGraph.set_axes('xlabelint'=>90)
#GGraph.set_axes('ylabelint'=>30)


gphysout = maketime( dir, iyrs, iyre, gphys )

# 全球平均
# 緯度ごとに経度方向の格子点間隔が異なるため面積で重みを付けなければならない.
# 参考:http://www.gfd-dennou.org/arch/ruby/ml/2011/msg00156.html
#
# cos phi を用いた重みの場合
cos_phi = (gphys.axis("lat").to_gphys * (PI/180.0)).cos
fact = cos_phi / cos_phi.mean
gphyscal = (gphysout * fact).mean("lon","lat")

# lat_weight を用いた場合
# 1 / na_lat_weight.sum が規格化された部分だからもし領域を区切る場合(緯度0-30渡帯など)はその間だけの足し合わせとなる.
#na_lat = GPhys::NetCDF_IO.open(dir+'/'+vname+".nc", "lat").val
#na_lat_weight = GPhys::NetCDF_IO.open(dir+'/'+vname+".nc", "lat_weight").val
#nlat = na_lat.size
#
#gphyscal = (gphysout * na_lat_weight.reshape(1, nlat) / na_lat_weight.sum).mean('lon').sum('lat')


# 作図
GGraph.line(gphyscal,true, 'annotate'=>false)
DCL::uxmttl('T', ' ', 1.0)
#DCL::uxmttl('T', title, -1.0)


DCL::grcls
if File.exists?('./sagyou.nc') then
  File.delete('./sagyou.nc')
end
