﻿# -*- coding: utf-8 -*-
#
$LOAD_PATH.push(Dir.pwd)
require 'gphys_const'
require 'gphys_methods'
require 'gphys_time'
require "numru/ggraph"
include NumRu
include NMath

ls_file_dir = ARGV[0]
vname = ARGV[1]
iyrs = ARGV[2].to_i
iyre = ARGV[3].to_i
lat = ARGV[4].to_i
ls_array = []
dirs = []
legend_array = []
index_array = []

ARGV[5].split("_").each do |ls|
  ls_array << ls.to_i
end

ARGV[6].split("!").each do |dir|
  dirs << dir.to_s
end

ARGV[7].split("!").each do |legend|
  if legend == "true"
    dirs.each do |dir|
      legend_array << true
    end
  elsif /_SPACE_/ =~ legend
    legend_array << legend.gsub(/_SPACE_/, ' ').to_s
  else
    legend_array << legend.to_s
  end
end

p ARGV[8]
ARGV[8].split("_").each do |index_comp|
  index_array << index_comp.to_s
end
p index_array
gphys_array = []

index = 11
type = 1

#level_max=200
level_max = 1e-1

#level_min=1000
level_min = 200

max = nil
min = nil
#Ls270,lat-25
#surface
#MSF
#max = 60
#min = -80

#more_high
#MSF
#max = 16
#min = 0

#Ls90,lat25
#surface
#MSF
#max = 35
#min = -35

#more_high
#MSF
max = 0
min = -9


time = ls_to_time(iyrs, iyre, ls_file_dir, ls_array)

if vname == 'MSF'
  vnameinfile = 'V'
elsif vname == 'ANGMOM'
  vnameinfile = 'U'
else
  vnameinfile = vname
end
if vname == 'AllRadiation'
  dirs.each do |dir|
    gphys = GPhys::IO.open( dir+'/'+'DTempDtMNIR.nc', 'DTempDtMNIR' )
    gphys2 = GPhys::IO.open( dir+'/'+'DTempDtRadL.nc', 'DTempDtRadL' )
    gphys3 = GPhys::IO.open( dir+'/'+'DTempDtRadS.nc', 'DTempDtRadS' )
    gphyszm = (3700 * 24) * (gphys.cut("time"=>time[0].to_i..time[1].to_i, 'lat'=>lat) + gphys2.cut("time"=>time[0].to_i..time[1].to_i, 'lat'=>lat) + gphys3.cut("time" =>time[0].to_i..time[1].to_i, 'lat'=>lat)).mean('lon','time').copy  
    gphyszm.rename("AllRadiation")
    gphyszm.set_att("long_name","Radiation Heating")
    gphyszm.set_att("units","K day-1")
    gphys_array << gphyszm
  end
elsif vname == 'Budget'
  dirs.each do |dir|
    vnames = ['DTempDtMNIR','DTempDtDryConv','DTempDtMajCompPhaseChange','DTempDtRadL','DTempDtRadS','DTempDtVDiff']
    #vnames = ['DTempDtMNIR','DTempDtRadL','DTempDtRadS','DTempDtVDiff']
    #vnames = ['DTempDtVDiff', 'DTempDtDryConv']
    gphys = GPhys::IO.open( dir+ '/' + 'DTempDtDyn.nc', 'DTempDtDyn')
    #gphys = GPhys::IO.open( dir+ '/' + 'DTempDtDryConv.nc', 'DTempDtDryConv')
    #  gphyszm = (3700 * 24) * gphys.cut("time"=>time[0].to_i..time[1].to_i).mean("lon","time").copy
    #vnames.each do |vname|
    #  gphys = GPhys::IO.open( dir+ '/' + vname + '.nc', vname)
    #  gphysout = (3700 * 24) * gphys.cut("time"=>time[0].to_i..time[1].to_i).mean("lon","time").copy
    #  gphyszm = gphyszm + gphysout
    #end
    gphyszm = (3700 * 24) * gphys.cut("time"=>time[0].to_i..time[1].to_i, 'lat'=>lat).copy
    vnames.each do |vname|
      gphys = GPhys::IO.open( dir+ '/' + vname + '.nc', vname)
      gphysout = (3700 * 24) * gphys.cut("time"=>time[0].to_i..time[1].to_i, 'lat'=>lat).copy
      gphyszm = gphyszm + gphysout
    end
    gphyszm = gphyszm.mean("lon","time").copy
    gphyszm.rename("HeatBudget")
    gphyszm.set_att("long_name","Heating Budget")
    gphyszm.set_att("units","K day-1")
    gphys_array << gphyszm
  end
elsif vname == 'DTempDtDyn' || vname == 'DTempDtMNIR' || vname == 'DTempDtDryConv' || vname == 'DTempDtMajCompPhaseChange' || vname == 'DTempDtRadL' || vname == 'DTempDtRadS' || vname == 'DTempDtVDiff'
  dirs.each do |dir|
    gphys = GPhys::IO.open( dir+'/'+vname+'.nc', vname )
    gphyszm = (3700 * 24) * gphys.cut("time"=>time[0].to_i..time[1].to_i, 'lat'=>lat).mean('lon','time').copy
    gphyszm.set_att("units","K day-1")
    gphys_array << gphyszm
  end
else
  dirs.each do |dir|
    gphys = GPhys::IO.open( dir+'/'+vnameinfile+'.nc', vnameinfile )
    gphyszm = gphys.cut("time"=>time[0].to_i..time[1].to_i).mean('lon','time').copy
    if vname == 'MSF'
      gphyszm = calc_msf( gphyszm )
    elsif vname == 'ANGMOM'
      gphyszm = calc_angmom( gphyszm )
    elsif vname == 'DustDensScledOptDep'
      gphyszm = gphyszm / 2.0
      gphyszm = gphyszm * 1e4
      gphyszm.long_name = "dust density-scaled optical depth at infrared"
      gphyszm.units = "1e-4 m2 kg-1"
    end
    gphys_array << gphyszm.cut("lat"=>lat)
  end
end


#p "test1"

#rmiss = gphys.get_att('missing_value')[0]
#gphys = nan_to_rmiss(gphys, rmiss)

# max 値と min 値を表示
#print("max:", gphyszm.cut("sig"=>sig_min..sig_max).max)
#print("min:", gphyszm.cut("sig"=>sig_min..sig_max).min)

DCL.gropn(2)
#DCL.sldiv('y',2,2)           # 2x2に画面分割, 'y'=yoko: 左上→右上→左下...
DCL.sgpset('lcntl', false)   # 制御文字を解釈しない
#DCL.sgpset('lfull',true)     # 全画面表示
DCL.uzfact(0.75)             # 座標軸の文字列サイズを 0.75 倍
#DCL.uzfact(0.7)             # 座標軸の文字列サイズを 0.75 倍
DCL.sgpset('lfprop',true)    # プロポーショナルフォントを使う

#DCL.glpset('lmiss',true)
#DCL.glpset('rmiss',rmiss)
DCLExt.gl_set_params('lmiss'=>true)

#< GGraph による 描画 >
# Earth
#GGraph.set_fig 'itr'=>2, 'viewport'=>[0.15,0.85,0.15,0.6], 'yrev'=>'units:Pa', 'window'=>[-90,90,1e5,1e3]
# Mars
#GGraph.set_fig 'itr'=>2, 'viewport'=>[0.15,0.85,0.15,0.6], 'yrev'=>'units:Pa', 'window'=>[-90,90,1e3,1e-1]
#p "test6"
#GGraph.set_fig 'itr'=>2, 'viewport'=>[0.15,0.85,0.15,0.6], 'yrev'=>'units:Pa', 'window'=>[-90,90,1e3,1e-2]
#GGraph.set_axes('yside'=>'lr','xside'=>'tb')
#GGraph.set_axes('xlabelint'=>30)
#GGraph.set_fig 'window'=>[min,max,sig_min,sig_max]
GGraph.set_fig('itr'=>2, 'window'=>[min,max,level_min,level_max])

#p levels.length
#p patterns.length
if index_array[0] == "true"
  for dir_num in 0..dirs.length-1
    if dir_num == 0 
      GGraph.line(gphys_array[dir_num].cut("level"=>level_min..level_max), true, 'index'=>index, 'type'=>type, 'annotate'=>false, 'legend'=>legend_array[dir_num], 'exchange'=>true, 'max'=>max, 'min'=>min)
    else
      GGraph.line(gphys_array[dir_num].cut("level"=>level_min..level_max), false, 'index'=>index, 'type'=>type, 'annotate'=>false, 'legend'=>legend_array[dir_num], 'exchange'=>true, 'max'=>max, 'min'=>min)
    end
    index += 10
  end
else
  for dir_num in 0..dirs.length-1
    if dir_num == 0 
      p legend_array[dir_num]
      # max 値と min 値を表示
      print("max:", gphys_array[dir_num].cut("level"=>level_min..level_max).max)
      print("min:", gphys_array[dir_num].cut("level"=>level_min..level_max).min,"\n")
      
      GGraph.line(gphys_array[dir_num].cut("level"=>level_min..level_max), true, 'index'=>index_array[dir_num].to_i,'type'=>type, 'annotate'=>false, 'legend'=>legend_array[dir_num], 'exchange'=>true, 'max'=>max, 'min'=>min)
    else
      p legend_array[dir_num]
      # max 値と min 値を表示
      print("max:", gphys_array[dir_num].cut("level"=>level_min..level_max).max)
      print("min:", gphys_array[dir_num].cut("level"=>level_min..level_max).min,"\n")
      GGraph.line(gphys_array[dir_num].cut("level"=>level_min..level_max), false, 'index'=>index_array[dir_num].to_i,'type'=>type, 'annotate'=>false, 'legend'=>legend_array[dir_num], 'exchange'=>true, 'max'=>max, 'min'=>min)
    end
  end
end


DCL::uxmttl('T', ' ', 1.0)
#DCL::uxmttl('T', title, -1.0)

DCL.grcls
