!
!火星の地形を勾配とるスクリプト
! \nabla topog = (1/a \cos\varphi \DD{topog}{\lambda}, 1/a \DD{topog}{\phi})
program dtopdx
!  use ee_module
  use w_module
  use dc_types, only: DP
  use gtool_history
  implicit none

  integer, parameter :: im=64, jm=32
  integer, parameter :: nm=21
  integer, parameter :: km=64, lm =32

  real(8), parameter :: pi = 3.141591653589793
  real(8), parameter :: RPlanet = 3.396d6

  real(DP) :: xy_Topog(0:im-1, 1:jm)
  real(DP) :: dx_Topog(0:im-1,1:jm)
  real(DP) :: dy_Topog(0:im-1,1:jm)
  real(DP) :: w_Topog((nm + 1)*(nm + 1))
  !  real(DP) :: x_lon(0:im-1)
  !  real(DP) :: y_lat(1:jm)

  write(*,*)"test1"
  call HistoryGet('../sp_for_Mars_T021_MGS.nc', 'topog', xy_Topog)
  !call HistoryGet('../sp_for_Mars_T021_MGS.nc', 'lon', x_lon)
  !call HistoryGet('../sp_for_Mars_T021_MGS.nc', 'lat', y_lat)
  
  call w_Initial(nm,im,jm)
  write(*,*) "test2"
  dx_Topog = (1.0d0 / RPlanet) * xy_GradLon_w(w_xy(xy_Topog))
  dy_Topog = (1.0d0 / RPlanet) * xy_GradLat_w(w_xy(xy_Topog))
  call HistoryCreate( &
    & file='../tmp/dtopogdx.nc', title='longitude componets of gradient of Topog', &
    & source='SPMODEL', &
    & institution='', &
    & dims=(/'lon','lat'/), dimsizes=(/im,jm/),&
    & longnames=(/'longitude','latitude '/), &
    & units=(/'deg', 'deg'/), &
    & origin=0.0, interval=3700.0)
  call HistoryPut('lon',x_Lon*180/pi)
  call HistoryPut('lat',y_Lat*180/pi)

  call HistoryAddVariable( &
    & varname='dtopogdx', dims=(/'lon','lat'/), &
    & longname='longitude componets of gradient of topography', &
    & units='m', &
    & xtype='double')

  call HistoryPut('dtopogdx',dx_Topog)
  call HistoryClose
  call HistoryCreate( &
    & file='../tmp/dtopogdy.nc', title='latitude componets of gradient of Topog', &
    & source='SPMODEL', &
    & institution='', &
    & dims=(/'lon','lat'/), dimsizes=(/im,jm/),&
    & longnames=(/'longitude','latitude '/), &
    & units=(/'deg', 'deg'/), &
    & origin=0.0, interval=3700.0)
  call HistoryPut('lon',x_Lon*180/pi)
  call HistoryPut('lat',y_Lat*180/pi)

  call HistoryAddVariable( &
    & varname='dtopogdy', dims=(/'lon','lat'/), &
    & longname='latitude componets of gradient of topography', &
    & units='m', &
    & xtype='double')

  call HistoryPut('dtopogdy',dy_Topog)
  call HistoryClose
end program dtopdx
