﻿#!/usr/bin/env ruby
# -*- coding: utf-8 -*-
#これはDust.ncとPs.ncからDODを作るスクリプトである
# 2015/4/1 荻原弘尭

#-------------宣言文-------------------
require "numru/gphys"
require "../gphys_const"
include NumRu
include Math

#-------------ファイル定義--------------
dustfilename = "../../Dust.nc"
psfilename = "../../Ps.nc"
dod067filename = "../../DOD067.nc"
dodfilename = "../../DOD.nc"
#-------------変数定義-------------------
dust = GPhys::IO.open(dustfilename, 'Dust')
ps = GPhys::IO.open(psfilename, 'Ps')
sig_w = GPhys::IO.open(dustfilename, 'sig_weight')
imax,jmax,kmax, tmax = dust.shape

xyr_dod = NArray.float(imax,jmax,kmax+1)
xyz_deldod = NArray.float(imax,jmax,kmax)
#--------------計算----------------------
#for t in 0..tmax-1
#  for j in 0..jmax-1
#    for i in 0..imax-1
#       xy_Tau[i,j,t] =
#       sqrt((xy_TauX[i,j,t])**2.0 + xy_TauY[i,j,t]**2.0)
#    end
#  end
#end

timecount = dust.coord(-1).val
dodfile = NetCDF.create(dodfilename)
dod067 = NetCDF.open(dod067filename, mode="r")
dod067.each_dim do |dim|
  dodfile.def_dim(dim.name, dim.length_ul0)
end
dod067.each_var do |var|
  dodfile.redef 
  if var.name == 'DOD067'
    dod = dodfile.def_var('DOD', var.vartype, var.dims)
  else
    dod = dodfile.def_var(var.name, var.vartype, var.dims)
  end
  for i in 0..var.att_names.size - 1
    dod.put_att(var.att(var.att_names[i]).name, var.att(var.att_names[i]).get)
  end
  dodfile.enddef
  if var.name == 'time'
  elsif var.dim_names.index('time').nil?
    dod.put(var.get)
  else
    axnames = var.dim_names.size-1
    index = 0
    time = dodfile.var(var.dim_names[-1])
    array1 = Array.new(axnames,0)
    array2 = Array.new(axnames,0)
    timecount.each do |times|
      array1.fill(0,0..-1).push(index)
      array2.fill(-1,0..-1).push(index)
      for k in 0..kmax-2
        xyz_deldod[false,k] = 
          (3.0/4.0 * DustExtEff / (REff * RhoDust * Grav) * dust[false,k,index] * ps[false,index] * sig_w[k]).val
      end

      xyr_dod[false,kmax-1] = 0.0

      k = kmax-2
      while k >= 0
        xyr_dod[false, k] = xyr_dod[false, k+1] + xyz_deldod[false, k]
        k -= 1
      end

      dod.put(xyr_dod, "start"=>array1, "end"=>array2)
      time.put(times, "index"=>[index])
      array1.delete_at(-1)
      array2.delete_at(-1)
      index = index + 1
    end
  end
end
dodfile.redef
dod067.each_att do |global|
  dodfile.put_att(global.name, global.get)
end
dodfile.enddef
dod067.close
dodfile.close
