﻿#!/usr/bin/env ruby
# -*- coding: utf-8 -*-
#これはTauXB.ncとTauYB.ncから|Tau|を作るスクリプトである
# 2012/10/15 荻原弘尭

#-------------宣言文-------------------
require "numru/gphys"
include NumRu
include Math

#-------------ファイル定義--------------
tauxfilename = "../TauXB.nc"
tauyfilename = "../TauYB.nc"
taufilename = "../Tau.nc"
#-------------変数定義-------------------
taux = GPhys::IO.open(tauxfilename, 'TauXB')
tauy = GPhys::IO.open(tauyfilename, 'TauYB')
imax,jmax,tmax = taux.shape
xy_TauX = taux.val
xy_TauY = tauy.val

xy_Tau = NArray.float(imax,jmax,tmax)
#--------------計算----------------------
p "test"
for t in 0..tmax-1
  for j in 0..jmax-1
    for i in 0..imax-1
       xy_Tau[i,j,t] =
       sqrt((xy_TauX[i,j,t])**2.0 + xy_TauY[i,j,t]**2.0)
    end
  end
end

tau = taux.copy
tau.replace_val(xy_Tau)
tau.rename("Tau")
tau.set_att("long_name","surface stress")
tau.set_att("units","N m-1")

#-------------ファイル出力----------------
taufile=NetCDF.create(taufilename)
GPhys::IO.write(taufile,tau)
taufile.close
